' This file is part of Network Switcher.

' Network Switcher is free software: you can redistribute it and/or modify
' it under the terms of the GNU General Public License as published by
' the Free Software Foundation, either version 3 of the License, or
' (at your option) any later version.

' Network Switcher is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.

' You should have received a copy of the GNU General Public License
' along with Network Switcher. If not, see <http://www.gnu.org/licenses/>.
'
' Copyright 2007, Ricardo Amaral

Public Delegate Sub PluginDelegate()

Public Interface IHost

    Property DirectConnection() As Boolean
    Property ProxyAddress() As String
    Property ProxyPort() As Integer
    Property BypassLocal() As Boolean

End Interface

Public Interface IPlugin

    Sub Initialize(ByVal Host As IHost)

    ReadOnly Property PluginName() As String
    ReadOnly Property PluginVersion() As String
    ReadOnly Property PluginAuthor() As String
    ReadOnly Property PluginDescription() As String

    Function GetMethods() As PluginDelegate()

End Interface
